<?php

/**
 * noweCv actions.
 *
 * @package    sam3
 * @subpackage noweCv
 * @author     Your name here
 */
class noweCvActions extends sfActions {

    public function executeIndex(sfWebRequest $request) {
        $this->cv_profile_list = CvProfilePeer::doSelect(new Criteria());
    }

    public function executeNew(sfWebRequest $request) {
        $this->form = new CvProfileForm();
        $this->ile_styli = $this->ileSkorek();
    }

    public function executeCreate(sfWebRequest $request) {
        $this->forward404Unless($request->isMethod('post'));

        $this->form = new CvProfileForm();

        $this->processForm($request, $this->form);
        $this->ile_styli = $this->ileSkorek();
        $this->getUser()->setFlash('notice', 'Formularz zawiera błędy. Wypełnij poprawnie pola.');
        $this->setTemplate('new');
    }

    public function executeEdit(sfWebRequest $request) {
        $this->forward404Unless($cv_profile = CvProfilePeer::retrieveByPk($request->getParameter('id')), sprintf('Object cv_profile does not exist (%s).', $request->getParameter('id')));
        $this->form = new CvProfileForm($cv_profile);

        $cv = CvProfilePeer::retrieveByPk($request->getParameter('id'));

        $criteria = new Criteria();
        $criteria->add(CvOsiagnieciaKursyPeer::CV_PROFILE, $request->getParameter('id'));
        $criteria->add(CvOsiagnieciaKursyPeer::TYP, 1);
        $dane = CvOsiagnieciaKursyPeer::doSelectWithI18n($criteria);

        $this->osiagniecia = array();
        foreach ($dane as $list) {
            $this->osiagniecia[] = new CvOsiagnieciaKursyForm($list);
        }

        $criteria = new Criteria();
        $criteria->add(CvOsiagnieciaKursyPeer::CV_PROFILE, $request->getParameter('id'));
        $criteria->add(CvOsiagnieciaKursyPeer::TYP, 2);
        $dane = CvOsiagnieciaKursyPeer::doSelectWithI18n($criteria);

        $this->kursy = array();
        foreach ($dane as $list) {
            $this->kursy[] = new CvOsiagnieciaKursyForm($list);
        }

        $criteria = new Criteria();
        $criteria->add(CvWyksztalcenieZawodPeer::CV_PROFILE, $request->getParameter('id'));
        $criteria->add(CvWyksztalcenieZawodPeer::TYP, 1);
        $dane = CvWyksztalcenieZawodPeer::doSelectWithI18n($criteria);

        $this->wyksztalcenie = array();
        foreach ($dane as $list) {
            $this->wyksztalcenie[] = new CvWyksztalcenieZawodForm($list);
        }

        $criteria = new Criteria();
        $criteria->add(CvWyksztalcenieZawodPeer::CV_PROFILE, $request->getParameter('id'));
        $criteria->add(CvWyksztalcenieZawodPeer::TYP, 2);
        $dane = CvWyksztalcenieZawodPeer::doSelectWithI18n($criteria);

        $this->zawod = array();
        foreach ($dane as $list) {
            $this->zawod[] = new CvWyksztalcenieZawodForm($list);
        }

        $criteria = new Criteria();
        $criteria->add(CvUmiejetnosciJezykiPeer::CV_PROFILE, $request->getParameter('id'));
        $criteria->add(CvUmiejetnosciJezykiPeer::TYP, 1);
        $dane = CvUmiejetnosciJezykiPeer::doSelectWithI18n($criteria);

        $this->umiejetnosci = array();
        foreach ($dane as $list) {
            $this->umiejetnosci[] = new CvUmiejetnosciJezykiForm($list);
        }

        $criteria = new Criteria();
        $criteria->add(CvUmiejetnosciJezykiPeer::CV_PROFILE, $request->getParameter('id'));
        $criteria->add(CvUmiejetnosciJezykiPeer::TYP, 2);
        $dane = CvUmiejetnosciJezykiPeer::doSelectWithI18n($criteria);

        $this->jezyki = array();
        foreach ($dane as $list) {
            $this->jezyki[] = new CvUmiejetnosciJezykiForm($list);
        }

        $criteria = new Criteria();
        $criteria->add(CvInfoZainteresowaniaPeer::CV_PROFILE, $request->getParameter('id'));
        $criteria->add(CvInfoZainteresowaniaPeer::TYP, 1);
        $dane = CvInfoZainteresowaniaPeer::doSelectWithI18n($criteria);

        $this->info = array();
        foreach ($dane as $list) {
            $this->info[] = new CvInfoZainteresowaniaForm($list);
        }

        $criteria = new Criteria();
        $criteria->add(CvInfoZainteresowaniaPeer::CV_PROFILE, $request->getParameter('id'));
        $criteria->add(CvInfoZainteresowaniaPeer::TYP, 2);
        $dane = CvInfoZainteresowaniaPeer::doSelectWithI18n($criteria);

        $this->zainteresowania = array();
        foreach ($dane as $list) {
            $this->zainteresowania[] = new CvInfoZainteresowaniaForm($list);
        }

        $this->ile_styli = $this->ileSkorek();
    }

    public function executeUpdate(sfWebRequest $request) {
        $this->forward404Unless($request->isMethod('post') || $request->isMethod('put'));
        $this->forward404Unless($cv_profile = CvProfilePeer::retrieveByPk($request->getParameter('id')), sprintf('Object cv_profile does not exist (%s).', $request->getParameter('id')));
        $this->form = new CvProfileForm($cv_profile);

        $this->processForm($request, $this->form);
        $this->redirect('@cv_edit?id=' . $request->getParameter('id'));
    }

    public function executeDelete(sfWebRequest $request) {
        $this->forward404Unless($cv_profile = CvProfilePeer::retrieveByPk($request->getParameter('id')), sprintf('Object cv_profile does not exist (%s).', $request->getParameter('id')));
        $cv_profile->delete();

        $this->redirect('@homepage');
    }

    protected function processForm(sfWebRequest $request, sfForm $form) {
        $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
        if ($form->isValid()) {
            $cv_profile = $form->save();
	
            if ($form->getValue('zdjecie_delete') == 'on') {
                $path_file = sfConfig::get('sf_upload_dir') . "/cv";
                if (is_file($path_file . $form->getValue('zdjecie'))) {
                    @unlink($path_file . $form->getValue('zdjecie'));
                }
            } else {
            
                $directory = sfConfig::get('sf_upload_dir') . "/cv";
                    if (!is_dir($directory)):
                        mkdir($directory, 0775, true);
                    endif;

                if ($form->getValue('zdjecie') != ''):
                    $zdjecie = $form->getValue('zdjecie');
                    $thumbnail = new sfThumbnail('150', '150');
                    $thumbnail->loadFile($zdjecie);
                    $thumbnail->save($zdjecie, 'image/jpeg');
                endif;
            }

            $this->redirect('@cv_edit?id=' . $cv_profile->getId());
        }
    }

    public function ileSkorek() {
        $i = 0; //ile mamy skorek dla cv?
        while (true) {
            $name = 'cv_' . ($i + 1);
            if (is_readable($this->getContext()->getModuleDirectory() . DIRECTORY_SEPARATOR . "templates" . DIRECTORY_SEPARATOR . "_" . $name . ".php")) {
                $i++;
            } else {
                break;
            }
        }
        return $i;
    }

    public function executePodglad(sfWebRequest $request) {
        $this->setLayout('layout');
        $this->cv = CvProfilePeer::retrieveByPk($request->getParameter('id'));

        $wyksztalcenie = $this->cv->getCvWyksztalcenieZawods(new Criteria());
        $this->wyksztalcenie = array();
        $this->zawod = array();
        foreach ($wyksztalcenie as $dod) {
            if ($dod->getTyp() == 1)
                $this->wyksztalcenie[] = $dod;
            else
                $this->zawod[] = $dod;
        }

        $kursy = $this->cv->getCvOsiagnieciaKursys(new Criteria());
        $this->kursy = array();
        $this->osiagniecia = array();
        foreach ($kursy as $dod) {
            if ($dod->getTyp() == 2)
                $this->kursy[] = $dod;
            else
                $this->osiagniecia[] = $dod;
        }



        $umiejetnosci = $this->cv->getCvUmiejetnosciJezykis(new Criteria());
        $this->umiejetnosci = array();
        $this->jezyki = array();
        foreach ($umiejetnosci as $dod) {
            if ($dod->getTyp() == 1)
                $this->umiejetnosci[] = $dod;
            else
                $this->jezyki[] = $dod;
        }


        $info = $this->cv->getCvInfoZainteresowanias(new Criteria());
        $this->info = array();
        $this->zainteresowania = array();
        foreach ($info as $dod) {
            if ($dod->getTyp() == 1)
                $this->info[] = $dod;
            else
                $this->zainteresowania[] = $dod;
        }
    }

    public function executeGenerujCv(sfWebRequest $request) {
        //zapisanie pdfa
        sfContext::getInstance()->getConfiguration()->loadHelpers('Funkcje');

        $config = sfTCPDFPluginConfigHandler::loadConfig('cv');


        $cv = CvProfilePeer::retrieveByPk($request->getParameter('id'));

        $wyksztalcenie = $cv->getCvWyksztalcenieZawods(new Criteria());
        $this->wyksztalcenie = array();
        $this->zawod = array();
        foreach ($wyksztalcenie as $dod) {
            if ($dod->getTyp() == 1)
                $this->wyksztalcenie[] = $dod;
            else
                $this->zawod[] = $dod;
        }

        $kursy = $cv->getCvOsiagnieciaKursys(new Criteria());
        $this->kursy = array();
        $this->osiagniecia = array();
        foreach ($kursy as $dod) {
            if ($dod->getTyp() == 2)
                $this->kursy[] = $dod;
            else
                $this->osiagniecia[] = $dod;
        }



        $umiejetnosci = $cv->getCvUmiejetnosciJezykis(new Criteria());
        $this->umiejetnosci = array();
        $this->jezyki = array();
        foreach ($umiejetnosci as $dod) {
            if ($dod->getTyp() == 1)
                $this->umiejetnosci[] = $dod;
            else
                $this->jezyki[] = $dod;
        }


        $info = $cv->getCvInfoZainteresowanias(new Criteria());
        $this->info = array();
        $this->zainteresowania = array();
        foreach ($info as $dod) {
            if ($dod->getTyp() == 1)
                $this->info[] = $dod;
            else
                $this->zainteresowania[] = $dod;
        }

        // pdf object
        $pdf = new sfTCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
        // remove default header/footer
        $pdf->setPrintHeader(false);
        $pdf->setPrintFooter(false);

        // settings
        $naglowek = '';

        $pdf->SetFont("FreeSerif", "", 12);
        $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
        $pdf->setHeaderFont(array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
        $pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE, $naglowek);
        $pdf->setFooterFont(array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
        $pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
        $pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

        //$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
        $pdf->SetCellPadding(0);
        //$pdf->setFooterMargin(0);
        // init pdf doc
        $pdf->AliasNbPages();

        $pdf->AddPage();


        try {
            $html = $this->getPartial('cv_' . $cv->getStyl(), array('cv' => $cv, 'wyksztalcenie' => $this->wyksztalcenie, 'zawod' => $this->zawod, 'kursy' => $this->kursy, 'osiagniecia' => $this->osiagniecia, 'umiejetnosci' => $this->umiejetnosci, 'jezyki' => $this->jezyki, 'info' => $this->info, 'zainteresowania' => $this->zainteresowania));
        } catch (Exception $e) {
            $html = $this->getPartial('cv_1', array('cv' => $cv));
        }

        $current_x = $pdf->getX();
        $current_y = $pdf->getY();
        $pdf->writeHTMLCell(180, 0, $current_x, $current_y, $html, 0, 0, 0);
        //footer

        $pdf->lastPage();
        $pdf->SetAutoPageBreak(TRUE, 0);
        $pdf->SetFontSize(8);

        $pdf->SetY(-35);
        $current_x = $pdf->getX();
        $current_y = $pdf->getY();
        

        try {
            $footer = $this->getPartial('footer_' . $cv->getStyl(), array('cv' => $cv));
        } catch (Exception $e) {
            $footer = $this->getPartial('footer_1', array('cv' => $cv));
        }

        //  $footer = $this->getPartial('footer', array('cv' => $cv));
        $pdf->writeHTMLCell(0, 0, $current_x, $current_y, $footer, 0, 0, 0);

        // output
        $pdf->Output('cv.pdf', 'D');
        }

    public function prepareDownload($outFilename, $ext) {
        header('Content-Type: application/' . $ext . ';charset=UTF-8');
        header('Content-Disposition: attachment;filename=' . $outFilename);
        error_reporting(1);
        return sfView::HEADER_ONLY;
    }

    public function executeGetCv(sfWebRequest $request) {
        if (($this->id = $this->getUser()->getAttribute('id', null, 'cv')) == null)
            $this->forward404();

        $id = $this->id;

        $cv = CvProfilePeer::retrieveByPK($id);
        if (!$cv)
            return $this->renderText('Brak pliku.');
        $src = 'cv.pdf';
        $name = 'cv.pdf';
        $name = str_replace(' ', '_', $name);
        $file_name = explode('.', $src);
        $this->prepareDownload($name, $file_name[count($file_name) - 1]);
        readfile(sfConfig::get('sf_upload_dir') . '/cv/' . $src);
        exit();
    }

    public function executePost(sfWebRequest $request) {
        if (($this->id = $this->getUser()->getAttribute('id', null, 'cv')) == null)
            $this->forward404();
    }

}
