<?php

/**
 * noweCvInfoZainteresowania actions.
 *
 * @package    sam3
 * @subpackage noweCvInfoZainteresowania
 * @author     Your name here
 */
class noweCvInfoZainteresowaniaActions extends sfActions {

    public function executeSave(sfWebRequest $request) {
        $cultures = JezykTblPeer::getCulturesForModul('cvcv');
        if ($request->isXmlHttpRequest()):
            $cv = $request->getParameter('cv_info_zainteresowania');
            $cv_info_zainteresowania = new CvInfoZainteresowania();
            $cv_info_zainteresowania->setCvProfile($request->getParameter('cvid'));
            $cv_info_zainteresowania->setTyp($request->getParameter('typ'));

            foreach ($cultures as $cult) {
                $cv_info_zainteresowania->setOpis($cv[$cult]['opis']);
            }

            if (($cv[$cult]['opis'] != '')):
                $cv_info_zainteresowania->save();
                if ($request->getParameter('typ') == 1):
                    $this->getUser()->setFlash('informacje_notice', 'Zapisano pozycje.');
                else:
                    $this->getUser()->setFlash('zainteresowania_notice', 'Zapisano pozycje.');
                endif;
            else:
                if ($request->getParameter('typ') == 1):
                    $this->getUser()->setFlash('informacje_notice', 'Nie można zapisać pustego formularza.');
                else:
                    $this->getUser()->setFlash('zainteresowania_notice', 'Nie można zapisać pustego formularza.');
                endif;
            endif;
        endif;

        return self::executeUpdateView($request);
    }

    public function executeUpdate(sfWebRequest $request) {
        $cultures = JezykTblPeer::getCulturesForModul('cvcv');
        if ($request->isXmlHttpRequest()):
            $cv = $request->getParameter('cv_info_zainteresowania');
            $cv_info_zainteresowania = CvInfoZainteresowaniaPeer::retrieveByPK($request->getParameter('id'));
            $cv_info_zainteresowania->setCvProfile($request->getParameter('cvid'));
            $cv_info_zainteresowania->setTyp($request->getParameter('typ'));

            foreach ($cultures as $cult) {
                $cv_info_zainteresowania->setOpis($cv[$cult]['opis']);
            }
            if (($cv[$cult]['opis'] != '')):
                $cv_info_zainteresowania->save();
                if ($request->getParameter('typ') == 1):
                    $this->getUser()->setFlash('informacje_notice', 'Zapisano pozycje.');
                else:
                    $this->getUser()->setFlash('zainteresowania_notice', 'Zapisano pozycje.');
                endif;
            else:
                if ($request->getParameter('typ') == 1):
                    $this->getUser()->setFlash('informacje_notice', 'Nie można zapisać pustego formularza.');
                else:
                    $this->getUser()->setFlash('zainteresowania_notice', 'Nie można zapisać pustego formularza.');
                endif;
            endif;
        endif;
        return self::executeUpdateView($request);
    }

    public function executeDelete(sfWebRequest $request) {
        if ($request->isXmlHttpRequest()):
            $this->forward404Unless($cv_info_zainteresowania = CvInfoZainteresowaniaPeer::retrieveByPk($request->getParameter('id')), sprintf('Object cv_info_zainteresowania does not exist (%s).', $request->getParameter('id')));
            $cv_info_zainteresowania->delete();
            if ($request->getParameter('typ') == 1):
                $this->getUser()->setFlash('informacje_notice', 'Usunieto pozycję.');
            else:
                $this->getUser()->setFlash('zainteresowania_notice', 'Usunięto pozycję.');
            endif;

        endif;
        return self::executeUpdateView($request);
    }

    public function executeUpdateView(sfWebRequest $request) {
        $this->setLayout(false);
        $criteria = new Criteria();
        $criteria->add(CvInfoZainteresowaniaPeer::CV_PROFILE, $request->getParameter('cvid'));
        $criteria->add(CvInfoZainteresowaniaPeer::TYP, 1);
        $dane = CvInfoZainteresowaniaPeer::doSelectWithI18n($criteria);

        $this->info = array();
        foreach ($dane as $list) {
            $this->info[] = new CvInfoZainteresowaniaForm($list);
        }

        $criteria = new Criteria();
        $criteria->add(CvInfoZainteresowaniaPeer::CV_PROFILE, $request->getParameter('cvid'));
        $criteria->add(CvInfoZainteresowaniaPeer::TYP, 2);
        $dane = CvInfoZainteresowaniaPeer::doSelectWithI18n($criteria);

        $this->zainteresowania = array();
        foreach ($dane as $list) {
            $this->zainteresowania[] = new CvInfoZainteresowaniaForm($list);
        }

        if ($request->getParameter('typ') == 1):
            return $this->renderPartial('list_informacje', array('info' => $this->info, 'cvid' => $request->getParameter('cvid')));
        else:
            return $this->renderPartial('list_zainteresowania', array('zainteresowania' => $this->zainteresowania, 'cvid' => $request->getParameter('cvid')));
        endif;
    }

}
