<?php

/**
 * CvProfile form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class CvProfileForm extends BaseCvProfileForm
{
    public function configure() {
        $this->setWidgets(array(
            'id' => new sfWidgetFormInputHidden(),
            'telefon' => new sfWidgetFormInput(),
            'email' => new sfWidgetFormInput(),
            'data_urodzenia' => new sfWidgetFormI18nDate(array('culture'=>'pl','format' => '%year% - %month% - %day%','years' => array_combine(range(date('Y'), 1970), range(date('Y'), 1970)))),
            
            'zdjecie' => new sfWidgetFormInputFileEditable(array(
                'file_src' => ($this->getObject()->getZdjecie())?'/uploads/cv/'.$this->getObject()->getZdjecie():'/images/portal/no_picture.png',
                'edit_mode' => !$this->isNew(),
                'is_image' => true,
                'delete_label' => 'Usuń zdjęcie',
                'with_delete' => true
            )),
            'ip' => new sfWidgetFormInputHidden(),
            'styl' => new sfWidgetFormInput(),
        ));

        $this->setValidators(array(
            'id' => new sfValidatorPropelChoice(array('model' => 'CvProfile', 'column' => 'id', 'required' => false)),
            'telefon' => new sfValidatorString(array('required' => false)),
            'email' => new sfValidatorEmail(array('required' => false)),
            'data_urodzenia' => new sfValidatorDate(array('required' => false)),
            'zdjecie' => new sfValidatorFile(array(
                'required' => false,
                'path' => sfConfig::get('sf_upload_dir').'/cv',
                'mime_types' => 'web_images',
                'max_size' => '1048576',
                ), array(
                    'max_size' => 'Plik jest większy niż 1 MB!',
                    'mime_types' => 'Dozwolone są tylko pliki formatu .jpg, .jpeg, .gif, .png! '
            )),
             
            'zdjecie_delete' => new sfValidatorPass(),
            'ip' => new sfValidatorString(array('max_length' => 39, 'required' => false)),
            'styl' => new sfValidatorInteger(array('required' => false)),
        ));
        
        $this->widgetSchema->setLabels(array(
        // Dane osobowe 
            'telefon' => 'Telefon',
            'email' => 'E-mail',
            'data_urodzenia' => 'Data urodzenia',
            'zdjecie' => 'Zdjęcie',
            'styl' => 'Styl CV'
        ));
        

        $this->widgetSchema->setHelps(array(
        // Dane osobowe 
            'telefon' => 'Podaj swój numer telefonu (komórkowego lub stacjonarnego).',
            'email' => 'Podaj swój adres poczty elektronicznej.',
            'data_urodzenia' => 'Wybierz datę urodzenia.',
            'zdjecie' => 'Dodaj zdjęcie. Dozwolone formaty plików to: .jpg, .jpeg, .gif, .png. Plik nie powinien przekraczać 1MB.',
            'styl' => 'Wybierz styl CV'
        ));

        $this->embedI18n(array('pl'));
        
        $this->widgetSchema->setNameFormat('cv_profile[%s]');
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    }
}
