<?php

/**
 * CvProfileI18n form.
 *
 * @package    sam3
 * @subpackage form
 * @author     Your name here
 */
class CvProfileI18nForm extends BaseCvProfileI18nForm
{
  protected static $stan_cywilny = array('','panna', 'kawaler', 'w związku małżeńskim', 'wolny');
  public function configure() {
        parent::configure();

        $this->setWidgets(array(
            'id' => new sfWidgetFormInputHidden(),
            'cv_profile' => new sfWidgetFormInputHidden(),
            'imie_nazwisko' => new sfWidgetFormInput(),
            'ulica' => new sfWidgetFormInput(),
            'kod' => new sfWidgetFormInput(),
            'poczta' => new sfWidgetFormInput(),
            'miasto' => new sfWidgetFormInput(),
            'stan_cywilny' => new sfWidgetFormSelect(array('choices' => self::$stan_cywilny)),
        ));

        $this->setValidators(array(
            'id' => new sfValidatorPropelChoice(array('model' => 'CvProfile', 'column' => 'id', 'required' => false)),
            'created_at' => new sfValidatorDateTime(array('required' => false)),
            // Dane osobowe 
            'imie_nazwisko' => new sfValidatorString(array('max_length' => 255)),
            'ulica' => new sfValidatorString(array('max_length' => 127)),
            'kod' => new sfValidatorString(array('max_length' => 10)),
            'poczta' => new sfValidatorString(array('required' => false, 'max_length' => 127)),
            'miasto' => new sfValidatorString(array('max_length' => 127)),
            'stan_cywilny' => new sfValidatorChoice(array('choices' => array_keys(self::$stan_cywilny)),array('required' => false)),
        ));

        $this->widgetSchema->setHelps(array(
        // Dane osobowe 
            'imie_nazwisko' => 'W tym polu podaj swoje imię i nazwisko.',
            'stan_cywilny' => 'Podaj swój stan cywilny.',
            'ulica' => 'Podaj nazwę ulicy i numer domu.',
            'poczta' => 'Wpisz nazwę miasta do którego jest przypisany kod jeśli jest inne niż miasto zamieszkania.',
            'kod' => 'Wpisz kod pocztowy miejscowości, w której mieszkasz w formacie 00-000.',
            'miasto' => 'Podaj nazwę miejscowości, w której mieszkasz',
        ));
        
        $this->widgetSchema->setLabels(array(
        // Dane osobowe 
            'imie_nazwisko' => 'Imię i nazwisko *',
            'ulica' => 'Ulica *',
            'kod' => 'Kod pocztowy *',
            'poczta' => 'Poczta',
            'miasto' => 'Miasto *',
            'stan_cywilny' => 'Stan cywilny',          
        ));
        

        $this->widgetSchema->setNameFormat('cv_profile[%s]');
        $this->getWidgetSchema()->getFormFormatter()->setHelpFormat('%help%');
        $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    }
}
