<?php


abstract class BaseCv extends BaseObject  implements Persistent {


  const PEER = 'CvPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $created_at;

	
	protected $nazwisko;

	
	protected $ulica;

	
	protected $miejscowosc;

	
	protected $kod_pocztowy;

	
	protected $telefon;

	
	protected $fax;

	
	protected $email;

	
	protected $wyksztalcenie;

	
	protected $praca;

	
	protected $kursy;

	
	protected $zainteresowania;

	
	protected $dodatkowe;

	
	protected $zdjecie;

	
	protected $jezyk1;

	
	protected $jezyk2;

	
	protected $jezyk3;

	
	protected $ip;

	
	protected $styl;

	
	protected $styl_jezyk;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->telefon = '';
		$this->fax = '';
		$this->email = '';
		$this->zdjecie = '';
		$this->jezyk1 = '';
		$this->jezyk2 = '';
		$this->jezyk3 = '';
		$this->ip = '';
		$this->styl_jezyk = 'pl';
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getNazwisko()
	{
		return $this->nazwisko;
	}

	
	public function getUlica()
	{
		return $this->ulica;
	}

	
	public function getMiejscowosc()
	{
		return $this->miejscowosc;
	}

	
	public function getKodPocztowy()
	{
		return $this->kod_pocztowy;
	}

	
	public function getTelefon()
	{
		return $this->telefon;
	}

	
	public function getFax()
	{
		return $this->fax;
	}

	
	public function getEmail()
	{
		return $this->email;
	}

	
	public function getWyksztalcenie()
	{
		return $this->wyksztalcenie;
	}

	
	public function getPraca()
	{
		return $this->praca;
	}

	
	public function getKursy()
	{
		return $this->kursy;
	}

	
	public function getZainteresowania()
	{
		return $this->zainteresowania;
	}

	
	public function getDodatkowe()
	{
		return $this->dodatkowe;
	}

	
	public function getZdjecie()
	{
		return $this->zdjecie;
	}

	
	public function getJezyk1()
	{
		return $this->jezyk1;
	}

	
	public function getJezyk2()
	{
		return $this->jezyk2;
	}

	
	public function getJezyk3()
	{
		return $this->jezyk3;
	}

	
	public function getIp()
	{
		return $this->ip;
	}

	
	public function getStyl()
	{
		return $this->styl;
	}

	
	public function getStylJezyk()
	{
		return $this->styl_jezyk;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CvPeer::ID;
		}

		return $this;
	} 
	
	public function setCreatedAt($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			
			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = CvPeer::CREATED_AT;
			}
		} 
		return $this;
	} 
	
	public function setNazwisko($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->nazwisko !== $v) {
			$this->nazwisko = $v;
			$this->modifiedColumns[] = CvPeer::NAZWISKO;
		}

		return $this;
	} 
	
	public function setUlica($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->ulica !== $v) {
			$this->ulica = $v;
			$this->modifiedColumns[] = CvPeer::ULICA;
		}

		return $this;
	} 
	
	public function setMiejscowosc($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->miejscowosc !== $v) {
			$this->miejscowosc = $v;
			$this->modifiedColumns[] = CvPeer::MIEJSCOWOSC;
		}

		return $this;
	} 
	
	public function setKodPocztowy($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->kod_pocztowy !== $v) {
			$this->kod_pocztowy = $v;
			$this->modifiedColumns[] = CvPeer::KOD_POCZTOWY;
		}

		return $this;
	} 
	
	public function setTelefon($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->telefon !== $v || $v === '') {
			$this->telefon = $v;
			$this->modifiedColumns[] = CvPeer::TELEFON;
		}

		return $this;
	} 
	
	public function setFax($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->fax !== $v || $v === '') {
			$this->fax = $v;
			$this->modifiedColumns[] = CvPeer::FAX;
		}

		return $this;
	} 
	
	public function setEmail($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->email !== $v || $v === '') {
			$this->email = $v;
			$this->modifiedColumns[] = CvPeer::EMAIL;
		}

		return $this;
	} 
	
	public function setWyksztalcenie($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->wyksztalcenie !== $v) {
			$this->wyksztalcenie = $v;
			$this->modifiedColumns[] = CvPeer::WYKSZTALCENIE;
		}

		return $this;
	} 
	
	public function setPraca($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->praca !== $v) {
			$this->praca = $v;
			$this->modifiedColumns[] = CvPeer::PRACA;
		}

		return $this;
	} 
	
	public function setKursy($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->kursy !== $v) {
			$this->kursy = $v;
			$this->modifiedColumns[] = CvPeer::KURSY;
		}

		return $this;
	} 
	
	public function setZainteresowania($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->zainteresowania !== $v) {
			$this->zainteresowania = $v;
			$this->modifiedColumns[] = CvPeer::ZAINTERESOWANIA;
		}

		return $this;
	} 
	
	public function setDodatkowe($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->dodatkowe !== $v) {
			$this->dodatkowe = $v;
			$this->modifiedColumns[] = CvPeer::DODATKOWE;
		}

		return $this;
	} 
	
	public function setZdjecie($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->zdjecie !== $v || $v === '') {
			$this->zdjecie = $v;
			$this->modifiedColumns[] = CvPeer::ZDJECIE;
		}

		return $this;
	} 
	
	public function setJezyk1($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->jezyk1 !== $v || $v === '') {
			$this->jezyk1 = $v;
			$this->modifiedColumns[] = CvPeer::JEZYK1;
		}

		return $this;
	} 
	
	public function setJezyk2($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->jezyk2 !== $v || $v === '') {
			$this->jezyk2 = $v;
			$this->modifiedColumns[] = CvPeer::JEZYK2;
		}

		return $this;
	} 
	
	public function setJezyk3($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->jezyk3 !== $v || $v === '') {
			$this->jezyk3 = $v;
			$this->modifiedColumns[] = CvPeer::JEZYK3;
		}

		return $this;
	} 
	
	public function setIp($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->ip !== $v || $v === '') {
			$this->ip = $v;
			$this->modifiedColumns[] = CvPeer::IP;
		}

		return $this;
	} 
	
	public function setStyl($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->styl !== $v) {
			$this->styl = $v;
			$this->modifiedColumns[] = CvPeer::STYL;
		}

		return $this;
	} 
	
	public function setStylJezyk($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->styl_jezyk !== $v || $v === 'pl') {
			$this->styl_jezyk = $v;
			$this->modifiedColumns[] = CvPeer::STYL_JEZYK;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(CvPeer::TELEFON,CvPeer::FAX,CvPeer::EMAIL,CvPeer::ZDJECIE,CvPeer::JEZYK1,CvPeer::JEZYK2,CvPeer::JEZYK3,CvPeer::IP,CvPeer::STYL_JEZYK))) {
				return false;
			}

			if ($this->telefon !== '') {
				return false;
			}

			if ($this->fax !== '') {
				return false;
			}

			if ($this->email !== '') {
				return false;
			}

			if ($this->zdjecie !== '') {
				return false;
			}

			if ($this->jezyk1 !== '') {
				return false;
			}

			if ($this->jezyk2 !== '') {
				return false;
			}

			if ($this->jezyk3 !== '') {
				return false;
			}

			if ($this->ip !== '') {
				return false;
			}

			if ($this->styl_jezyk !== 'pl') {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->created_at = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->nazwisko = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->ulica = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->miejscowosc = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->kod_pocztowy = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->telefon = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->fax = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->email = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->wyksztalcenie = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->praca = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->kursy = ($row[$startcol + 11] !== null) ? (string) $row[$startcol + 11] : null;
			$this->zainteresowania = ($row[$startcol + 12] !== null) ? (string) $row[$startcol + 12] : null;
			$this->dodatkowe = ($row[$startcol + 13] !== null) ? (string) $row[$startcol + 13] : null;
			$this->zdjecie = ($row[$startcol + 14] !== null) ? (string) $row[$startcol + 14] : null;
			$this->jezyk1 = ($row[$startcol + 15] !== null) ? (string) $row[$startcol + 15] : null;
			$this->jezyk2 = ($row[$startcol + 16] !== null) ? (string) $row[$startcol + 16] : null;
			$this->jezyk3 = ($row[$startcol + 17] !== null) ? (string) $row[$startcol + 17] : null;
			$this->ip = ($row[$startcol + 18] !== null) ? (string) $row[$startcol + 18] : null;
			$this->styl = ($row[$startcol + 19] !== null) ? (int) $row[$startcol + 19] : null;
			$this->styl_jezyk = ($row[$startcol + 20] !== null) ? (string) $row[$startcol + 20] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 21; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Cv object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = CvPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			CvPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(CvPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			CvPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = CvPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CvPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CvPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = CvPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CvPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getCreatedAt();
				break;
			case 2:
				return $this->getNazwisko();
				break;
			case 3:
				return $this->getUlica();
				break;
			case 4:
				return $this->getMiejscowosc();
				break;
			case 5:
				return $this->getKodPocztowy();
				break;
			case 6:
				return $this->getTelefon();
				break;
			case 7:
				return $this->getFax();
				break;
			case 8:
				return $this->getEmail();
				break;
			case 9:
				return $this->getWyksztalcenie();
				break;
			case 10:
				return $this->getPraca();
				break;
			case 11:
				return $this->getKursy();
				break;
			case 12:
				return $this->getZainteresowania();
				break;
			case 13:
				return $this->getDodatkowe();
				break;
			case 14:
				return $this->getZdjecie();
				break;
			case 15:
				return $this->getJezyk1();
				break;
			case 16:
				return $this->getJezyk2();
				break;
			case 17:
				return $this->getJezyk3();
				break;
			case 18:
				return $this->getIp();
				break;
			case 19:
				return $this->getStyl();
				break;
			case 20:
				return $this->getStylJezyk();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = CvPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getCreatedAt(),
			$keys[2] => $this->getNazwisko(),
			$keys[3] => $this->getUlica(),
			$keys[4] => $this->getMiejscowosc(),
			$keys[5] => $this->getKodPocztowy(),
			$keys[6] => $this->getTelefon(),
			$keys[7] => $this->getFax(),
			$keys[8] => $this->getEmail(),
			$keys[9] => $this->getWyksztalcenie(),
			$keys[10] => $this->getPraca(),
			$keys[11] => $this->getKursy(),
			$keys[12] => $this->getZainteresowania(),
			$keys[13] => $this->getDodatkowe(),
			$keys[14] => $this->getZdjecie(),
			$keys[15] => $this->getJezyk1(),
			$keys[16] => $this->getJezyk2(),
			$keys[17] => $this->getJezyk3(),
			$keys[18] => $this->getIp(),
			$keys[19] => $this->getStyl(),
			$keys[20] => $this->getStylJezyk(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CvPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setCreatedAt($value);
				break;
			case 2:
				$this->setNazwisko($value);
				break;
			case 3:
				$this->setUlica($value);
				break;
			case 4:
				$this->setMiejscowosc($value);
				break;
			case 5:
				$this->setKodPocztowy($value);
				break;
			case 6:
				$this->setTelefon($value);
				break;
			case 7:
				$this->setFax($value);
				break;
			case 8:
				$this->setEmail($value);
				break;
			case 9:
				$this->setWyksztalcenie($value);
				break;
			case 10:
				$this->setPraca($value);
				break;
			case 11:
				$this->setKursy($value);
				break;
			case 12:
				$this->setZainteresowania($value);
				break;
			case 13:
				$this->setDodatkowe($value);
				break;
			case 14:
				$this->setZdjecie($value);
				break;
			case 15:
				$this->setJezyk1($value);
				break;
			case 16:
				$this->setJezyk2($value);
				break;
			case 17:
				$this->setJezyk3($value);
				break;
			case 18:
				$this->setIp($value);
				break;
			case 19:
				$this->setStyl($value);
				break;
			case 20:
				$this->setStylJezyk($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CvPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setCreatedAt($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setNazwisko($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setUlica($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setMiejscowosc($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setKodPocztowy($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTelefon($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setFax($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setEmail($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setWyksztalcenie($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setPraca($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setKursy($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setZainteresowania($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setDodatkowe($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setZdjecie($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setJezyk1($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setJezyk2($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setJezyk3($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setIp($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setStyl($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setStylJezyk($arr[$keys[20]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CvPeer::DATABASE_NAME);

		if ($this->isColumnModified(CvPeer::ID)) $criteria->add(CvPeer::ID, $this->id);
		if ($this->isColumnModified(CvPeer::CREATED_AT)) $criteria->add(CvPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(CvPeer::NAZWISKO)) $criteria->add(CvPeer::NAZWISKO, $this->nazwisko);
		if ($this->isColumnModified(CvPeer::ULICA)) $criteria->add(CvPeer::ULICA, $this->ulica);
		if ($this->isColumnModified(CvPeer::MIEJSCOWOSC)) $criteria->add(CvPeer::MIEJSCOWOSC, $this->miejscowosc);
		if ($this->isColumnModified(CvPeer::KOD_POCZTOWY)) $criteria->add(CvPeer::KOD_POCZTOWY, $this->kod_pocztowy);
		if ($this->isColumnModified(CvPeer::TELEFON)) $criteria->add(CvPeer::TELEFON, $this->telefon);
		if ($this->isColumnModified(CvPeer::FAX)) $criteria->add(CvPeer::FAX, $this->fax);
		if ($this->isColumnModified(CvPeer::EMAIL)) $criteria->add(CvPeer::EMAIL, $this->email);
		if ($this->isColumnModified(CvPeer::WYKSZTALCENIE)) $criteria->add(CvPeer::WYKSZTALCENIE, $this->wyksztalcenie);
		if ($this->isColumnModified(CvPeer::PRACA)) $criteria->add(CvPeer::PRACA, $this->praca);
		if ($this->isColumnModified(CvPeer::KURSY)) $criteria->add(CvPeer::KURSY, $this->kursy);
		if ($this->isColumnModified(CvPeer::ZAINTERESOWANIA)) $criteria->add(CvPeer::ZAINTERESOWANIA, $this->zainteresowania);
		if ($this->isColumnModified(CvPeer::DODATKOWE)) $criteria->add(CvPeer::DODATKOWE, $this->dodatkowe);
		if ($this->isColumnModified(CvPeer::ZDJECIE)) $criteria->add(CvPeer::ZDJECIE, $this->zdjecie);
		if ($this->isColumnModified(CvPeer::JEZYK1)) $criteria->add(CvPeer::JEZYK1, $this->jezyk1);
		if ($this->isColumnModified(CvPeer::JEZYK2)) $criteria->add(CvPeer::JEZYK2, $this->jezyk2);
		if ($this->isColumnModified(CvPeer::JEZYK3)) $criteria->add(CvPeer::JEZYK3, $this->jezyk3);
		if ($this->isColumnModified(CvPeer::IP)) $criteria->add(CvPeer::IP, $this->ip);
		if ($this->isColumnModified(CvPeer::STYL)) $criteria->add(CvPeer::STYL, $this->styl);
		if ($this->isColumnModified(CvPeer::STYL_JEZYK)) $criteria->add(CvPeer::STYL_JEZYK, $this->styl_jezyk);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CvPeer::DATABASE_NAME);

		$criteria->add(CvPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setNazwisko($this->nazwisko);

		$copyObj->setUlica($this->ulica);

		$copyObj->setMiejscowosc($this->miejscowosc);

		$copyObj->setKodPocztowy($this->kod_pocztowy);

		$copyObj->setTelefon($this->telefon);

		$copyObj->setFax($this->fax);

		$copyObj->setEmail($this->email);

		$copyObj->setWyksztalcenie($this->wyksztalcenie);

		$copyObj->setPraca($this->praca);

		$copyObj->setKursy($this->kursy);

		$copyObj->setZainteresowania($this->zainteresowania);

		$copyObj->setDodatkowe($this->dodatkowe);

		$copyObj->setZdjecie($this->zdjecie);

		$copyObj->setJezyk1($this->jezyk1);

		$copyObj->setJezyk2($this->jezyk2);

		$copyObj->setJezyk3($this->jezyk3);

		$copyObj->setIp($this->ip);

		$copyObj->setStyl($this->styl);

		$copyObj->setStylJezyk($this->styl_jezyk);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CvPeer();
		}
		return self::$peer;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
	}

} 