<?php


abstract class BaseCvOsiagnieciaKursy extends BaseObject  implements Persistent {


  const PEER = 'CvOsiagnieciaKursyPeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $cv_profile;

	
	protected $typ;

	
	protected $data;

	
	protected $aCvProfileRelatedByCvProfile;

	
	protected $collCvOsiagnieciaKursyI18ns;

	
	private $lastCvOsiagnieciaKursyI18nCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getCvProfile()
	{
		return $this->cv_profile;
	}

	
	public function getTyp()
	{
		return $this->typ;
	}

	
	public function getData($format = 'Y-m-d')
	{
		if ($this->data === null) {
			return null;
		}


		if ($this->data === '0000-00-00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->data);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->data, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CvOsiagnieciaKursyPeer::ID;
		}

		return $this;
	} 
	
	public function setCvProfile($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->cv_profile !== $v) {
			$this->cv_profile = $v;
			$this->modifiedColumns[] = CvOsiagnieciaKursyPeer::CV_PROFILE;
		}

		if ($this->aCvProfileRelatedByCvProfile !== null && $this->aCvProfileRelatedByCvProfile->getId() !== $v) {
			$this->aCvProfileRelatedByCvProfile = null;
		}

		return $this;
	} 
	
	public function setTyp($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->typ !== $v) {
			$this->typ = $v;
			$this->modifiedColumns[] = CvOsiagnieciaKursyPeer::TYP;
		}

		return $this;
	} 
	
	public function setData($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->data !== null || $dt !== null ) {
			
			$currNorm = ($this->data !== null && $tmpDt = new DateTime($this->data)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->data = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = CvOsiagnieciaKursyPeer::DATA;
			}
		} 
		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->cv_profile = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->typ = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->data = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating CvOsiagnieciaKursy object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aCvProfileRelatedByCvProfile !== null && $this->cv_profile !== $this->aCvProfileRelatedByCvProfile->getId()) {
			$this->aCvProfileRelatedByCvProfile = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvOsiagnieciaKursyPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = CvOsiagnieciaKursyPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aCvProfileRelatedByCvProfile = null;
			$this->collCvOsiagnieciaKursyI18ns = null;
			$this->lastCvOsiagnieciaKursyI18nCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvOsiagnieciaKursyPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			CvOsiagnieciaKursyPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvOsiagnieciaKursyPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			CvOsiagnieciaKursyPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aCvProfileRelatedByCvProfile !== null) {
				if ($this->aCvProfileRelatedByCvProfile->isModified() || ($this->aCvProfileRelatedByCvProfile->getCulture() && $this->aCvProfileRelatedByCvProfile->getCurrentCvProfileI18n()->isModified()) || $this->aCvProfileRelatedByCvProfile->isNew()) {
					$affectedRows += $this->aCvProfileRelatedByCvProfile->save($con);
				}
				$this->setCvProfileRelatedByCvProfile($this->aCvProfileRelatedByCvProfile);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = CvOsiagnieciaKursyPeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CvOsiagnieciaKursyPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CvOsiagnieciaKursyPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collCvOsiagnieciaKursyI18ns !== null) {
				foreach ($this->collCvOsiagnieciaKursyI18ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aCvProfileRelatedByCvProfile !== null) {
				if (!$this->aCvProfileRelatedByCvProfile->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCvProfileRelatedByCvProfile->getValidationFailures());
				}
			}


			if (($retval = CvOsiagnieciaKursyPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCvOsiagnieciaKursyI18ns !== null) {
					foreach ($this->collCvOsiagnieciaKursyI18ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CvOsiagnieciaKursyPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getCvProfile();
				break;
			case 2:
				return $this->getTyp();
				break;
			case 3:
				return $this->getData();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = CvOsiagnieciaKursyPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getCvProfile(),
			$keys[2] => $this->getTyp(),
			$keys[3] => $this->getData(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CvOsiagnieciaKursyPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setCvProfile($value);
				break;
			case 2:
				$this->setTyp($value);
				break;
			case 3:
				$this->setData($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CvOsiagnieciaKursyPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setCvProfile($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setTyp($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setData($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CvOsiagnieciaKursyPeer::DATABASE_NAME);

		if ($this->isColumnModified(CvOsiagnieciaKursyPeer::ID)) $criteria->add(CvOsiagnieciaKursyPeer::ID, $this->id);
		if ($this->isColumnModified(CvOsiagnieciaKursyPeer::CV_PROFILE)) $criteria->add(CvOsiagnieciaKursyPeer::CV_PROFILE, $this->cv_profile);
		if ($this->isColumnModified(CvOsiagnieciaKursyPeer::TYP)) $criteria->add(CvOsiagnieciaKursyPeer::TYP, $this->typ);
		if ($this->isColumnModified(CvOsiagnieciaKursyPeer::DATA)) $criteria->add(CvOsiagnieciaKursyPeer::DATA, $this->data);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CvOsiagnieciaKursyPeer::DATABASE_NAME);

		$criteria->add(CvOsiagnieciaKursyPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setCvProfile($this->cv_profile);

		$copyObj->setTyp($this->typ);

		$copyObj->setData($this->data);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getCvOsiagnieciaKursyI18ns() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addCvOsiagnieciaKursyI18n($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CvOsiagnieciaKursyPeer();
		}
		return self::$peer;
	}

	
	public function setCvProfileRelatedByCvProfile(CvProfile $v = null)
	{
		if ($v === null) {
			$this->setCvProfile(NULL);
		} else {
			$this->setCvProfile($v->getId());
		}

		$this->aCvProfileRelatedByCvProfile = $v;

						if ($v !== null) {
			$v->addCvOsiagnieciaKursy($this);
		}

		return $this;
	}


	
	public function getCvProfileRelatedByCvProfile(PropelPDO $con = null)
	{
		if ($this->aCvProfileRelatedByCvProfile === null && ($this->cv_profile !== null)) {
			$c = new Criteria(CvProfilePeer::DATABASE_NAME);
			$c->add(CvProfilePeer::ID, $this->cv_profile);
			$this->aCvProfileRelatedByCvProfile = CvProfilePeer::doSelectOne($c, $con);
			
		}
		return $this->aCvProfileRelatedByCvProfile;
	}

	
	public function clearCvOsiagnieciaKursyI18ns()
	{
		$this->collCvOsiagnieciaKursyI18ns = null; 	}

	
	public function initCvOsiagnieciaKursyI18ns()
	{
		$this->collCvOsiagnieciaKursyI18ns = array();
	}

	
	public function getCvOsiagnieciaKursyI18ns($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvOsiagnieciaKursyPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCvOsiagnieciaKursyI18ns === null) {
			if ($this->isNew()) {
			   $this->collCvOsiagnieciaKursyI18ns = array();
			} else {

				$criteria->add(CvOsiagnieciaKursyI18nPeer::ID, $this->id);

				CvOsiagnieciaKursyI18nPeer::addSelectColumns($criteria);
				$this->collCvOsiagnieciaKursyI18ns = CvOsiagnieciaKursyI18nPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvOsiagnieciaKursyI18nPeer::ID, $this->id);

				CvOsiagnieciaKursyI18nPeer::addSelectColumns($criteria);
				if (!isset($this->lastCvOsiagnieciaKursyI18nCriteria) || !$this->lastCvOsiagnieciaKursyI18nCriteria->equals($criteria)) {
					$this->collCvOsiagnieciaKursyI18ns = CvOsiagnieciaKursyI18nPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCvOsiagnieciaKursyI18nCriteria = $criteria;
		return $this->collCvOsiagnieciaKursyI18ns;
	}

	
	public function countCvOsiagnieciaKursyI18ns(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvOsiagnieciaKursyPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collCvOsiagnieciaKursyI18ns === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(CvOsiagnieciaKursyI18nPeer::ID, $this->id);

				$count = CvOsiagnieciaKursyI18nPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvOsiagnieciaKursyI18nPeer::ID, $this->id);

				if (!isset($this->lastCvOsiagnieciaKursyI18nCriteria) || !$this->lastCvOsiagnieciaKursyI18nCriteria->equals($criteria)) {
					$count = CvOsiagnieciaKursyI18nPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collCvOsiagnieciaKursyI18ns);
				}
			} else {
				$count = count($this->collCvOsiagnieciaKursyI18ns);
			}
		}
		return $count;
	}

	
	public function addCvOsiagnieciaKursyI18n(CvOsiagnieciaKursyI18n $l)
	{
		if ($this->collCvOsiagnieciaKursyI18ns === null) {
			$this->initCvOsiagnieciaKursyI18ns();
		}
		if (!in_array($l, $this->collCvOsiagnieciaKursyI18ns, true)) { 			array_push($this->collCvOsiagnieciaKursyI18ns, $l);
			$l->setCvOsiagnieciaKursy($this);
		}
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collCvOsiagnieciaKursyI18ns) {
				foreach ((array) $this->collCvOsiagnieciaKursyI18ns as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collCvOsiagnieciaKursyI18ns = null;
			$this->aCvProfileRelatedByCvProfile = null;
	}


  
  public function getCulture()
  {
    return $this->culture;
  }

  
  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getNazwa($culture = null)
  {
    return $this->getCurrentCvOsiagnieciaKursyI18n($culture)->getNazwa();
  }

  public function setNazwa($value, $culture = null)
  {
    $this->getCurrentCvOsiagnieciaKursyI18n($culture)->setNazwa($value);
  }

  public function getSzczegoly($culture = null)
  {
    return $this->getCurrentCvOsiagnieciaKursyI18n($culture)->getSzczegoly();
  }

  public function setSzczegoly($value, $culture = null)
  {
    $this->getCurrentCvOsiagnieciaKursyI18n($culture)->setSzczegoly($value);
  }

  protected $current_i18n = array();

  public function getCurrentCvOsiagnieciaKursyI18n($culture = null)
  {
    if (is_null($culture))
    {
      $culture = is_null($this->culture) ? sfPropel::getDefaultCulture() : $this->culture;
    }

    if (!isset($this->current_i18n[$culture]))
    {
      $obj = $this->isNew() ? null : CvOsiagnieciaKursyI18nPeer::retrieveByPK($this->getId(), $culture);
      if ($obj)
      {
        $this->setCvOsiagnieciaKursyI18nForCulture($obj, $culture);
      }
      else
      {
        $this->setCvOsiagnieciaKursyI18nForCulture(new CvOsiagnieciaKursyI18n(), $culture);
        $this->current_i18n[$culture]->setCulture($culture);
      }
    }

    return $this->current_i18n[$culture];
  }

  public function setCvOsiagnieciaKursyI18nForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addCvOsiagnieciaKursyI18n($object);
  }

} 