<?php


abstract class BaseCvProfile extends BaseObject  implements Persistent {


  const PEER = 'CvProfilePeer';

	
	protected static $peer;

	
	protected $id;

	
	protected $telefon;

	
	protected $email;

	
	protected $data_urodzenia;

	
	protected $zdjecie;

	
	protected $ip;

	
	protected $styl;

	
	protected $styl_jezyk;

	
	protected $collCvProfileI18ns;

	
	private $lastCvProfileI18nCriteria = null;

	
	protected $collCvOsiagnieciaKursys;

	
	private $lastCvOsiagnieciaKursyCriteria = null;

	
	protected $collCvUmiejetnosciJezykis;

	
	private $lastCvUmiejetnosciJezykiCriteria = null;

	
	protected $collCvWyksztalcenieZawods;

	
	private $lastCvWyksztalcenieZawodCriteria = null;

	
	protected $collCvInfoZainteresowanias;

	
	private $lastCvInfoZainteresowaniaCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
		$this->telefon = '';
		$this->email = '';
		$this->zdjecie = '';
		$this->ip = '';
		$this->styl_jezyk = 'pl';
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getTelefon()
	{
		return $this->telefon;
	}

	
	public function getEmail()
	{
		return $this->email;
	}

	
	public function getDataUrodzenia($format = 'Y-m-d')
	{
		if ($this->data_urodzenia === null) {
			return null;
		}


		if ($this->data_urodzenia === '0000-00-00') {
									return null;
		} else {
			try {
				$dt = new DateTime($this->data_urodzenia);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->data_urodzenia, true), $x);
			}
		}

		if ($format === null) {
						return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	
	public function getZdjecie()
	{
		return $this->zdjecie;
	}

	
	public function getIp()
	{
		return $this->ip;
	}

	
	public function getStyl()
	{
		return $this->styl;
	}

	
	public function getStylJezyk()
	{
		return $this->styl_jezyk;
	}

	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CvProfilePeer::ID;
		}

		return $this;
	} 
	
	public function setTelefon($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->telefon !== $v || $v === '') {
			$this->telefon = $v;
			$this->modifiedColumns[] = CvProfilePeer::TELEFON;
		}

		return $this;
	} 
	
	public function setEmail($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->email !== $v || $v === '') {
			$this->email = $v;
			$this->modifiedColumns[] = CvProfilePeer::EMAIL;
		}

		return $this;
	} 
	
	public function setDataUrodzenia($v)
	{
						if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
									try {
				if (is_numeric($v)) { 					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
															$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->data_urodzenia !== null || $dt !== null ) {
			
			$currNorm = ($this->data_urodzenia !== null && $tmpDt = new DateTime($this->data_urodzenia)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) 					)
			{
				$this->data_urodzenia = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = CvProfilePeer::DATA_URODZENIA;
			}
		} 
		return $this;
	} 
	
	public function setZdjecie($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->zdjecie !== $v || $v === '') {
			$this->zdjecie = $v;
			$this->modifiedColumns[] = CvProfilePeer::ZDJECIE;
		}

		return $this;
	} 
	
	public function setIp($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->ip !== $v || $v === '') {
			$this->ip = $v;
			$this->modifiedColumns[] = CvProfilePeer::IP;
		}

		return $this;
	} 
	
	public function setStyl($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->styl !== $v) {
			$this->styl = $v;
			$this->modifiedColumns[] = CvProfilePeer::STYL;
		}

		return $this;
	} 
	
	public function setStylJezyk($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->styl_jezyk !== $v || $v === 'pl') {
			$this->styl_jezyk = $v;
			$this->modifiedColumns[] = CvProfilePeer::STYL_JEZYK;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array(CvProfilePeer::TELEFON,CvProfilePeer::EMAIL,CvProfilePeer::ZDJECIE,CvProfilePeer::IP,CvProfilePeer::STYL_JEZYK))) {
				return false;
			}

			if ($this->telefon !== '') {
				return false;
			}

			if ($this->email !== '') {
				return false;
			}

			if ($this->zdjecie !== '') {
				return false;
			}

			if ($this->ip !== '') {
				return false;
			}

			if ($this->styl_jezyk !== 'pl') {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->telefon = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->email = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->data_urodzenia = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->zdjecie = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->ip = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->styl = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->styl_jezyk = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating CvProfile object", $e);
		}
	}

	
	public function ensureConsistency()
	{

	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvProfilePeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = CvProfilePeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->collCvProfileI18ns = null;
			$this->lastCvProfileI18nCriteria = null;

			$this->collCvOsiagnieciaKursys = null;
			$this->lastCvOsiagnieciaKursyCriteria = null;

			$this->collCvUmiejetnosciJezykis = null;
			$this->lastCvUmiejetnosciJezykiCriteria = null;

			$this->collCvWyksztalcenieZawods = null;
			$this->lastCvWyksztalcenieZawodCriteria = null;

			$this->collCvInfoZainteresowanias = null;
			$this->lastCvInfoZainteresowaniaCriteria = null;

		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvProfilePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			CvProfilePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvProfilePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			CvProfilePeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			if ($this->isNew() ) {
				$this->modifiedColumns[] = CvProfilePeer::ID;
			}

						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CvProfilePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CvProfilePeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			if ($this->collCvProfileI18ns !== null) {
				foreach ($this->collCvProfileI18ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collCvOsiagnieciaKursys !== null) {
				foreach ($this->collCvOsiagnieciaKursys as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collCvUmiejetnosciJezykis !== null) {
				foreach ($this->collCvUmiejetnosciJezykis as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collCvWyksztalcenieZawods !== null) {
				foreach ($this->collCvWyksztalcenieZawods as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collCvInfoZainteresowanias !== null) {
				foreach ($this->collCvInfoZainteresowanias as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = CvProfilePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collCvProfileI18ns !== null) {
					foreach ($this->collCvProfileI18ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collCvOsiagnieciaKursys !== null) {
					foreach ($this->collCvOsiagnieciaKursys as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collCvUmiejetnosciJezykis !== null) {
					foreach ($this->collCvUmiejetnosciJezykis as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collCvWyksztalcenieZawods !== null) {
					foreach ($this->collCvWyksztalcenieZawods as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collCvInfoZainteresowanias !== null) {
					foreach ($this->collCvInfoZainteresowanias as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CvProfilePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getTelefon();
				break;
			case 2:
				return $this->getEmail();
				break;
			case 3:
				return $this->getDataUrodzenia();
				break;
			case 4:
				return $this->getZdjecie();
				break;
			case 5:
				return $this->getIp();
				break;
			case 6:
				return $this->getStyl();
				break;
			case 7:
				return $this->getStylJezyk();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = CvProfilePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getTelefon(),
			$keys[2] => $this->getEmail(),
			$keys[3] => $this->getDataUrodzenia(),
			$keys[4] => $this->getZdjecie(),
			$keys[5] => $this->getIp(),
			$keys[6] => $this->getStyl(),
			$keys[7] => $this->getStylJezyk(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CvProfilePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setTelefon($value);
				break;
			case 2:
				$this->setEmail($value);
				break;
			case 3:
				$this->setDataUrodzenia($value);
				break;
			case 4:
				$this->setZdjecie($value);
				break;
			case 5:
				$this->setIp($value);
				break;
			case 6:
				$this->setStyl($value);
				break;
			case 7:
				$this->setStylJezyk($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CvProfilePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setTelefon($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setEmail($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDataUrodzenia($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setZdjecie($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setIp($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setStyl($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setStylJezyk($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);

		if ($this->isColumnModified(CvProfilePeer::ID)) $criteria->add(CvProfilePeer::ID, $this->id);
		if ($this->isColumnModified(CvProfilePeer::TELEFON)) $criteria->add(CvProfilePeer::TELEFON, $this->telefon);
		if ($this->isColumnModified(CvProfilePeer::EMAIL)) $criteria->add(CvProfilePeer::EMAIL, $this->email);
		if ($this->isColumnModified(CvProfilePeer::DATA_URODZENIA)) $criteria->add(CvProfilePeer::DATA_URODZENIA, $this->data_urodzenia);
		if ($this->isColumnModified(CvProfilePeer::ZDJECIE)) $criteria->add(CvProfilePeer::ZDJECIE, $this->zdjecie);
		if ($this->isColumnModified(CvProfilePeer::IP)) $criteria->add(CvProfilePeer::IP, $this->ip);
		if ($this->isColumnModified(CvProfilePeer::STYL)) $criteria->add(CvProfilePeer::STYL, $this->styl);
		if ($this->isColumnModified(CvProfilePeer::STYL_JEZYK)) $criteria->add(CvProfilePeer::STYL_JEZYK, $this->styl_jezyk);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);

		$criteria->add(CvProfilePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setTelefon($this->telefon);

		$copyObj->setEmail($this->email);

		$copyObj->setDataUrodzenia($this->data_urodzenia);

		$copyObj->setZdjecie($this->zdjecie);

		$copyObj->setIp($this->ip);

		$copyObj->setStyl($this->styl);

		$copyObj->setStylJezyk($this->styl_jezyk);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach ($this->getCvProfileI18ns() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addCvProfileI18n($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getCvOsiagnieciaKursys() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addCvOsiagnieciaKursy($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getCvUmiejetnosciJezykis() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addCvUmiejetnosciJezyki($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getCvWyksztalcenieZawods() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addCvWyksztalcenieZawod($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getCvInfoZainteresowanias() as $relObj) {
				if ($relObj !== $this) {  					$copyObj->addCvInfoZainteresowania($relObj->copy($deepCopy));
				}
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CvProfilePeer();
		}
		return self::$peer;
	}

	
	public function clearCvProfileI18ns()
	{
		$this->collCvProfileI18ns = null; 	}

	
	public function initCvProfileI18ns()
	{
		$this->collCvProfileI18ns = array();
	}

	
	public function getCvProfileI18ns($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCvProfileI18ns === null) {
			if ($this->isNew()) {
			   $this->collCvProfileI18ns = array();
			} else {

				$criteria->add(CvProfileI18nPeer::ID, $this->id);

				CvProfileI18nPeer::addSelectColumns($criteria);
				$this->collCvProfileI18ns = CvProfileI18nPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvProfileI18nPeer::ID, $this->id);

				CvProfileI18nPeer::addSelectColumns($criteria);
				if (!isset($this->lastCvProfileI18nCriteria) || !$this->lastCvProfileI18nCriteria->equals($criteria)) {
					$this->collCvProfileI18ns = CvProfileI18nPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCvProfileI18nCriteria = $criteria;
		return $this->collCvProfileI18ns;
	}

	
	public function countCvProfileI18ns(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collCvProfileI18ns === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(CvProfileI18nPeer::ID, $this->id);

				$count = CvProfileI18nPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvProfileI18nPeer::ID, $this->id);

				if (!isset($this->lastCvProfileI18nCriteria) || !$this->lastCvProfileI18nCriteria->equals($criteria)) {
					$count = CvProfileI18nPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collCvProfileI18ns);
				}
			} else {
				$count = count($this->collCvProfileI18ns);
			}
		}
		return $count;
	}

	
	public function addCvProfileI18n(CvProfileI18n $l)
	{
		if ($this->collCvProfileI18ns === null) {
			$this->initCvProfileI18ns();
		}
		if (!in_array($l, $this->collCvProfileI18ns, true)) { 			array_push($this->collCvProfileI18ns, $l);
			$l->setCvProfile($this);
		}
	}

	
	public function clearCvOsiagnieciaKursys()
	{
		$this->collCvOsiagnieciaKursys = null; 	}

	
	public function initCvOsiagnieciaKursys()
	{
		$this->collCvOsiagnieciaKursys = array();
	}

	
	public function getCvOsiagnieciaKursys($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCvOsiagnieciaKursys === null) {
			if ($this->isNew()) {
			   $this->collCvOsiagnieciaKursys = array();
			} else {

				$criteria->add(CvOsiagnieciaKursyPeer::CV_PROFILE, $this->id);

				CvOsiagnieciaKursyPeer::addSelectColumns($criteria);
				$this->collCvOsiagnieciaKursys = CvOsiagnieciaKursyPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvOsiagnieciaKursyPeer::CV_PROFILE, $this->id);

				CvOsiagnieciaKursyPeer::addSelectColumns($criteria);
				if (!isset($this->lastCvOsiagnieciaKursyCriteria) || !$this->lastCvOsiagnieciaKursyCriteria->equals($criteria)) {
					$this->collCvOsiagnieciaKursys = CvOsiagnieciaKursyPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCvOsiagnieciaKursyCriteria = $criteria;
		return $this->collCvOsiagnieciaKursys;
	}

	
	public function countCvOsiagnieciaKursys(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collCvOsiagnieciaKursys === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(CvOsiagnieciaKursyPeer::CV_PROFILE, $this->id);

				$count = CvOsiagnieciaKursyPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvOsiagnieciaKursyPeer::CV_PROFILE, $this->id);

				if (!isset($this->lastCvOsiagnieciaKursyCriteria) || !$this->lastCvOsiagnieciaKursyCriteria->equals($criteria)) {
					$count = CvOsiagnieciaKursyPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collCvOsiagnieciaKursys);
				}
			} else {
				$count = count($this->collCvOsiagnieciaKursys);
			}
		}
		return $count;
	}

	
	public function addCvOsiagnieciaKursy(CvOsiagnieciaKursy $l)
	{
		if ($this->collCvOsiagnieciaKursys === null) {
			$this->initCvOsiagnieciaKursys();
		}
		if (!in_array($l, $this->collCvOsiagnieciaKursys, true)) { 			array_push($this->collCvOsiagnieciaKursys, $l);
			$l->setCvProfileRelatedByCvProfile($this);
		}
	}

	
	public function clearCvUmiejetnosciJezykis()
	{
		$this->collCvUmiejetnosciJezykis = null; 	}

	
	public function initCvUmiejetnosciJezykis()
	{
		$this->collCvUmiejetnosciJezykis = array();
	}

	
	public function getCvUmiejetnosciJezykis($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCvUmiejetnosciJezykis === null) {
			if ($this->isNew()) {
			   $this->collCvUmiejetnosciJezykis = array();
			} else {

				$criteria->add(CvUmiejetnosciJezykiPeer::CV_PROFILE, $this->id);

				CvUmiejetnosciJezykiPeer::addSelectColumns($criteria);
				$this->collCvUmiejetnosciJezykis = CvUmiejetnosciJezykiPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvUmiejetnosciJezykiPeer::CV_PROFILE, $this->id);

				CvUmiejetnosciJezykiPeer::addSelectColumns($criteria);
				if (!isset($this->lastCvUmiejetnosciJezykiCriteria) || !$this->lastCvUmiejetnosciJezykiCriteria->equals($criteria)) {
					$this->collCvUmiejetnosciJezykis = CvUmiejetnosciJezykiPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCvUmiejetnosciJezykiCriteria = $criteria;
		return $this->collCvUmiejetnosciJezykis;
	}

	
	public function countCvUmiejetnosciJezykis(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collCvUmiejetnosciJezykis === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(CvUmiejetnosciJezykiPeer::CV_PROFILE, $this->id);

				$count = CvUmiejetnosciJezykiPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvUmiejetnosciJezykiPeer::CV_PROFILE, $this->id);

				if (!isset($this->lastCvUmiejetnosciJezykiCriteria) || !$this->lastCvUmiejetnosciJezykiCriteria->equals($criteria)) {
					$count = CvUmiejetnosciJezykiPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collCvUmiejetnosciJezykis);
				}
			} else {
				$count = count($this->collCvUmiejetnosciJezykis);
			}
		}
		return $count;
	}

	
	public function addCvUmiejetnosciJezyki(CvUmiejetnosciJezyki $l)
	{
		if ($this->collCvUmiejetnosciJezykis === null) {
			$this->initCvUmiejetnosciJezykis();
		}
		if (!in_array($l, $this->collCvUmiejetnosciJezykis, true)) { 			array_push($this->collCvUmiejetnosciJezykis, $l);
			$l->setCvProfileRelatedByCvProfile($this);
		}
	}

	
	public function clearCvWyksztalcenieZawods()
	{
		$this->collCvWyksztalcenieZawods = null; 	}

	
	public function initCvWyksztalcenieZawods()
	{
		$this->collCvWyksztalcenieZawods = array();
	}

	
	public function getCvWyksztalcenieZawods($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCvWyksztalcenieZawods === null) {
			if ($this->isNew()) {
			   $this->collCvWyksztalcenieZawods = array();
			} else {

				$criteria->add(CvWyksztalcenieZawodPeer::CV_PROFILE, $this->id);

				CvWyksztalcenieZawodPeer::addSelectColumns($criteria);
				$this->collCvWyksztalcenieZawods = CvWyksztalcenieZawodPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvWyksztalcenieZawodPeer::CV_PROFILE, $this->id);

				CvWyksztalcenieZawodPeer::addSelectColumns($criteria);
				if (!isset($this->lastCvWyksztalcenieZawodCriteria) || !$this->lastCvWyksztalcenieZawodCriteria->equals($criteria)) {
					$this->collCvWyksztalcenieZawods = CvWyksztalcenieZawodPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCvWyksztalcenieZawodCriteria = $criteria;
		return $this->collCvWyksztalcenieZawods;
	}

	
	public function countCvWyksztalcenieZawods(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collCvWyksztalcenieZawods === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(CvWyksztalcenieZawodPeer::CV_PROFILE, $this->id);

				$count = CvWyksztalcenieZawodPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvWyksztalcenieZawodPeer::CV_PROFILE, $this->id);

				if (!isset($this->lastCvWyksztalcenieZawodCriteria) || !$this->lastCvWyksztalcenieZawodCriteria->equals($criteria)) {
					$count = CvWyksztalcenieZawodPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collCvWyksztalcenieZawods);
				}
			} else {
				$count = count($this->collCvWyksztalcenieZawods);
			}
		}
		return $count;
	}

	
	public function addCvWyksztalcenieZawod(CvWyksztalcenieZawod $l)
	{
		if ($this->collCvWyksztalcenieZawods === null) {
			$this->initCvWyksztalcenieZawods();
		}
		if (!in_array($l, $this->collCvWyksztalcenieZawods, true)) { 			array_push($this->collCvWyksztalcenieZawods, $l);
			$l->setCvProfileRelatedByCvProfile($this);
		}
	}

	
	public function clearCvInfoZainteresowanias()
	{
		$this->collCvInfoZainteresowanias = null; 	}

	
	public function initCvInfoZainteresowanias()
	{
		$this->collCvInfoZainteresowanias = array();
	}

	
	public function getCvInfoZainteresowanias($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCvInfoZainteresowanias === null) {
			if ($this->isNew()) {
			   $this->collCvInfoZainteresowanias = array();
			} else {

				$criteria->add(CvInfoZainteresowaniaPeer::CV_PROFILE, $this->id);

				CvInfoZainteresowaniaPeer::addSelectColumns($criteria);
				$this->collCvInfoZainteresowanias = CvInfoZainteresowaniaPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvInfoZainteresowaniaPeer::CV_PROFILE, $this->id);

				CvInfoZainteresowaniaPeer::addSelectColumns($criteria);
				if (!isset($this->lastCvInfoZainteresowaniaCriteria) || !$this->lastCvInfoZainteresowaniaCriteria->equals($criteria)) {
					$this->collCvInfoZainteresowanias = CvInfoZainteresowaniaPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCvInfoZainteresowaniaCriteria = $criteria;
		return $this->collCvInfoZainteresowanias;
	}

	
	public function countCvInfoZainteresowanias(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(CvProfilePeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collCvInfoZainteresowanias === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(CvInfoZainteresowaniaPeer::CV_PROFILE, $this->id);

				$count = CvInfoZainteresowaniaPeer::doCount($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CvInfoZainteresowaniaPeer::CV_PROFILE, $this->id);

				if (!isset($this->lastCvInfoZainteresowaniaCriteria) || !$this->lastCvInfoZainteresowaniaCriteria->equals($criteria)) {
					$count = CvInfoZainteresowaniaPeer::doCount($criteria, $con);
				} else {
					$count = count($this->collCvInfoZainteresowanias);
				}
			} else {
				$count = count($this->collCvInfoZainteresowanias);
			}
		}
		return $count;
	}

	
	public function addCvInfoZainteresowania(CvInfoZainteresowania $l)
	{
		if ($this->collCvInfoZainteresowanias === null) {
			$this->initCvInfoZainteresowanias();
		}
		if (!in_array($l, $this->collCvInfoZainteresowanias, true)) { 			array_push($this->collCvInfoZainteresowanias, $l);
			$l->setCvProfileRelatedByCvProfile($this);
		}
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collCvProfileI18ns) {
				foreach ((array) $this->collCvProfileI18ns as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collCvOsiagnieciaKursys) {
				foreach ((array) $this->collCvOsiagnieciaKursys as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collCvUmiejetnosciJezykis) {
				foreach ((array) $this->collCvUmiejetnosciJezykis as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collCvWyksztalcenieZawods) {
				foreach ((array) $this->collCvWyksztalcenieZawods as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collCvInfoZainteresowanias) {
				foreach ((array) $this->collCvInfoZainteresowanias as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} 
		$this->collCvProfileI18ns = null;
		$this->collCvOsiagnieciaKursys = null;
		$this->collCvUmiejetnosciJezykis = null;
		$this->collCvWyksztalcenieZawods = null;
		$this->collCvInfoZainteresowanias = null;
	}


  
  public function getCulture()
  {
    return $this->culture;
  }

  
  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getImieNazwisko($culture = null)
  {
    return $this->getCurrentCvProfileI18n($culture)->getImieNazwisko();
  }

  public function setImieNazwisko($value, $culture = null)
  {
    $this->getCurrentCvProfileI18n($culture)->setImieNazwisko($value);
  }

  public function getUlica($culture = null)
  {
    return $this->getCurrentCvProfileI18n($culture)->getUlica();
  }

  public function setUlica($value, $culture = null)
  {
    $this->getCurrentCvProfileI18n($culture)->setUlica($value);
  }

  public function getKod($culture = null)
  {
    return $this->getCurrentCvProfileI18n($culture)->getKod();
  }

  public function setKod($value, $culture = null)
  {
    $this->getCurrentCvProfileI18n($culture)->setKod($value);
  }

  public function getPoczta($culture = null)
  {
    return $this->getCurrentCvProfileI18n($culture)->getPoczta();
  }

  public function setPoczta($value, $culture = null)
  {
    $this->getCurrentCvProfileI18n($culture)->setPoczta($value);
  }

  public function getMiasto($culture = null)
  {
    return $this->getCurrentCvProfileI18n($culture)->getMiasto();
  }

  public function setMiasto($value, $culture = null)
  {
    $this->getCurrentCvProfileI18n($culture)->setMiasto($value);
  }

  public function getStanCywilny($culture = null)
  {
    return $this->getCurrentCvProfileI18n($culture)->getStanCywilny();
  }

  public function setStanCywilny($value, $culture = null)
  {
    $this->getCurrentCvProfileI18n($culture)->setStanCywilny($value);
  }

  protected $current_i18n = array();

  public function getCurrentCvProfileI18n($culture = null)
  {
    if (is_null($culture))
    {
      $culture = is_null($this->culture) ? sfPropel::getDefaultCulture() : $this->culture;
    }

    if (!isset($this->current_i18n[$culture]))
    {
      $obj = $this->isNew() ? null : CvProfileI18nPeer::retrieveByPK($this->getId(), $culture);
      if ($obj)
      {
        $this->setCvProfileI18nForCulture($obj, $culture);
      }
      else
      {
        $this->setCvProfileI18nForCulture(new CvProfileI18n(), $culture);
        $this->current_i18n[$culture]->setCulture($culture);
      }
    }

    return $this->current_i18n[$culture];
  }

  public function setCvProfileI18nForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addCvProfileI18n($object);
  }

} 