<?php


abstract class BaseCvProfileI18n extends BaseObject  implements Persistent {


  const PEER = 'CvProfileI18nPeer';

	
	protected static $peer;

	
	protected $imie_nazwisko;

	
	protected $ulica;

	
	protected $kod;

	
	protected $poczta;

	
	protected $miasto;

	
	protected $stan_cywilny;

	
	protected $id;

	
	protected $culture;

	
	protected $aCvProfile;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	
	public function applyDefaultValues()
	{
	}

	
	public function getImieNazwisko()
	{
		return $this->imie_nazwisko;
	}

	
	public function getUlica()
	{
		return $this->ulica;
	}

	
	public function getKod()
	{
		return $this->kod;
	}

	
	public function getPoczta()
	{
		return $this->poczta;
	}

	
	public function getMiasto()
	{
		return $this->miasto;
	}

	
	public function getStanCywilny()
	{
		return $this->stan_cywilny;
	}

	
	public function getId()
	{
		return $this->id;
	}

	
	public function getCulture()
	{
		return $this->culture;
	}

	
	public function setImieNazwisko($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->imie_nazwisko !== $v) {
			$this->imie_nazwisko = $v;
			$this->modifiedColumns[] = CvProfileI18nPeer::IMIE_NAZWISKO;
		}

		return $this;
	} 
	
	public function setUlica($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->ulica !== $v) {
			$this->ulica = $v;
			$this->modifiedColumns[] = CvProfileI18nPeer::ULICA;
		}

		return $this;
	} 
	
	public function setKod($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->kod !== $v) {
			$this->kod = $v;
			$this->modifiedColumns[] = CvProfileI18nPeer::KOD;
		}

		return $this;
	} 
	
	public function setPoczta($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->poczta !== $v) {
			$this->poczta = $v;
			$this->modifiedColumns[] = CvProfileI18nPeer::POCZTA;
		}

		return $this;
	} 
	
	public function setMiasto($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->miasto !== $v) {
			$this->miasto = $v;
			$this->modifiedColumns[] = CvProfileI18nPeer::MIASTO;
		}

		return $this;
	} 
	
	public function setStanCywilny($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->stan_cywilny !== $v) {
			$this->stan_cywilny = $v;
			$this->modifiedColumns[] = CvProfileI18nPeer::STAN_CYWILNY;
		}

		return $this;
	} 
	
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CvProfileI18nPeer::ID;
		}

		if ($this->aCvProfile !== null && $this->aCvProfile->getId() !== $v) {
			$this->aCvProfile = null;
		}

		return $this;
	} 
	
	public function setCulture($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->culture !== $v) {
			$this->culture = $v;
			$this->modifiedColumns[] = CvProfileI18nPeer::CULTURE;
		}

		return $this;
	} 
	
	public function hasOnlyDefaultValues()
	{
						if (array_diff($this->modifiedColumns, array())) {
				return false;
			}

				return true;
	} 
	
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->imie_nazwisko = ($row[$startcol + 0] !== null) ? (string) $row[$startcol + 0] : null;
			$this->ulica = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->kod = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->poczta = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->miasto = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->stan_cywilny = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->id = ($row[$startcol + 6] !== null) ? (int) $row[$startcol + 6] : null;
			$this->culture = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

						return $startcol + 8; 
		} catch (Exception $e) {
			throw new PropelException("Error populating CvProfileI18n object", $e);
		}
	}

	
	public function ensureConsistency()
	{

		if ($this->aCvProfile !== null && $this->id !== $this->aCvProfile->getId()) {
			$this->aCvProfile = null;
		}
	} 
	
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvProfileI18nPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

				
		$stmt = CvProfileI18nPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); 
		if ($deep) {  
			$this->aCvProfile = null;
		} 	}

	
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvProfileI18nPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			CvProfileI18nPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CvProfileI18nPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$affectedRows = $this->doSave($con);
			$con->commit();
			CvProfileI18nPeer::addInstanceToPool($this);
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

												
			if ($this->aCvProfile !== null) {
				if ($this->aCvProfile->isModified() || ($this->aCvProfile->getCulture() && $this->aCvProfile->getCurrentCvProfileI18n()->isModified()) || $this->aCvProfile->isNew()) {
					$affectedRows += $this->aCvProfile->save($con);
				}
				$this->setCvProfile($this->aCvProfile);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CvProfileI18nPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setNew(false);
				} else {
					$affectedRows += CvProfileI18nPeer::doUpdate($this, $con);
				}

				$this->resetModified(); 			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aCvProfile !== null) {
				if (!$this->aCvProfile->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCvProfile->getValidationFailures());
				}
			}


			if (($retval = CvProfileI18nPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CvProfileI18nPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getImieNazwisko();
				break;
			case 1:
				return $this->getUlica();
				break;
			case 2:
				return $this->getKod();
				break;
			case 3:
				return $this->getPoczta();
				break;
			case 4:
				return $this->getMiasto();
				break;
			case 5:
				return $this->getStanCywilny();
				break;
			case 6:
				return $this->getId();
				break;
			case 7:
				return $this->getCulture();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = CvProfileI18nPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getImieNazwisko(),
			$keys[1] => $this->getUlica(),
			$keys[2] => $this->getKod(),
			$keys[3] => $this->getPoczta(),
			$keys[4] => $this->getMiasto(),
			$keys[5] => $this->getStanCywilny(),
			$keys[6] => $this->getId(),
			$keys[7] => $this->getCulture(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CvProfileI18nPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setImieNazwisko($value);
				break;
			case 1:
				$this->setUlica($value);
				break;
			case 2:
				$this->setKod($value);
				break;
			case 3:
				$this->setPoczta($value);
				break;
			case 4:
				$this->setMiasto($value);
				break;
			case 5:
				$this->setStanCywilny($value);
				break;
			case 6:
				$this->setId($value);
				break;
			case 7:
				$this->setCulture($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CvProfileI18nPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setImieNazwisko($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUlica($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setKod($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setPoczta($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setMiasto($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setStanCywilny($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setId($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setCulture($arr[$keys[7]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CvProfileI18nPeer::DATABASE_NAME);

		if ($this->isColumnModified(CvProfileI18nPeer::IMIE_NAZWISKO)) $criteria->add(CvProfileI18nPeer::IMIE_NAZWISKO, $this->imie_nazwisko);
		if ($this->isColumnModified(CvProfileI18nPeer::ULICA)) $criteria->add(CvProfileI18nPeer::ULICA, $this->ulica);
		if ($this->isColumnModified(CvProfileI18nPeer::KOD)) $criteria->add(CvProfileI18nPeer::KOD, $this->kod);
		if ($this->isColumnModified(CvProfileI18nPeer::POCZTA)) $criteria->add(CvProfileI18nPeer::POCZTA, $this->poczta);
		if ($this->isColumnModified(CvProfileI18nPeer::MIASTO)) $criteria->add(CvProfileI18nPeer::MIASTO, $this->miasto);
		if ($this->isColumnModified(CvProfileI18nPeer::STAN_CYWILNY)) $criteria->add(CvProfileI18nPeer::STAN_CYWILNY, $this->stan_cywilny);
		if ($this->isColumnModified(CvProfileI18nPeer::ID)) $criteria->add(CvProfileI18nPeer::ID, $this->id);
		if ($this->isColumnModified(CvProfileI18nPeer::CULTURE)) $criteria->add(CvProfileI18nPeer::CULTURE, $this->culture);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CvProfileI18nPeer::DATABASE_NAME);

		$criteria->add(CvProfileI18nPeer::ID, $this->id);
		$criteria->add(CvProfileI18nPeer::CULTURE, $this->culture);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getId();

		$pks[1] = $this->getCulture();

		return $pks;
	}

	
	public function setPrimaryKey($keys)
	{

		$this->setId($keys[0]);

		$this->setCulture($keys[1]);

	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setImieNazwisko($this->imie_nazwisko);

		$copyObj->setUlica($this->ulica);

		$copyObj->setKod($this->kod);

		$copyObj->setPoczta($this->poczta);

		$copyObj->setMiasto($this->miasto);

		$copyObj->setStanCywilny($this->stan_cywilny);

		$copyObj->setId($this->id);

		$copyObj->setCulture($this->culture);


		$copyObj->setNew(true);

	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CvProfileI18nPeer();
		}
		return self::$peer;
	}

	
	public function setCvProfile(CvProfile $v = null)
	{
		if ($v === null) {
			$this->setId(NULL);
		} else {
			$this->setId($v->getId());
		}

		$this->aCvProfile = $v;

						if ($v !== null) {
			$v->addCvProfileI18n($this);
		}

		return $this;
	}


	
	public function getCvProfile(PropelPDO $con = null)
	{
		if ($this->aCvProfile === null && ($this->id !== null)) {
			$c = new Criteria(CvProfilePeer::DATABASE_NAME);
			$c->add(CvProfilePeer::ID, $this->id);
			$this->aCvProfile = CvProfilePeer::doSelectOne($c, $con);
			
		}
		return $this->aCvProfile;
	}

	
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} 
			$this->aCvProfile = null;
	}

} 